Summary: X interface to the GDB, DBX and XDB debuggers
Name: ddd
Version: 3.2.1
Release: 1_nw1
Source0: ftp://ftp.gnu.org/gnu/ddd/ddd-%{version}.tar.gz
Copyright: GPL
Group: Development/Debuggers
URL: http://www.cs.tu-bs.de/softech/ddd/
Buildroot: /var/tmp/ddd-root

%description
Source package for the DDD debugger.  This package generates 3 different
RPMs for 3 different binary versions plus a common RPM with documentation.
The bin RPMs are:

+ ddd-dynamic    : completely dynamically linked
+ ddd-semistatic : Motif library statically linked, rest dynamically
+ ddd-static     : completely statically linked

%package dynamic
Summary: X interface to the GDB, DBX and XDB debuggers
Group: Development/Debuggers
Prefix: /usr

%description dynamic
Fully dynamically linked DDD binary that uses Motif 1.2 shared library -
lesstif v0.88.0 or higher will work.  The Data Display Debugger (DDD) is
a common graphical user interface for GDB, DBX, and XDB, the popular
UNIX debuggers.  Besides ``classical'' front-end features such as
viewing source texts, DDD provides a graphical data display, where data
structures are displayed as graphs.  A simple mouse click dereferences
pointers or views structure contents, updated each time the program
stops.  Using DDD, you can reason about your application by viewing its
data, not just by viewing it execute lines of source code.  Other DDD
features include: debugging of programs written in C, C++, Ada, Fortran,
Java, Perl, Pascal, Modula-2, or Modula-3; machine-level debugging;
hypertext source navigation and lookup; breakpoint, backtrace, and
history editors; preferences and settings editors; program execution in
terminal emulator window; debugging on remote host; on-line manual;
interactive help on the Motif user interface; GDB/DBX/XDB command-line
interface with full editing, history, search, and completion
capabilities.  DDD has been designed to compete with well-known
commercial debuggers.  For more info on DDD see
http://www.cs.tu-bs.de/softech/ddd/

%package semistatic
Summary: X interface to the GDB, DBX and XDB debuggers
Group: Development/Debuggers
Prefix: /usr

%description semistatic
Dynamically linked DDD binary with Motif 1.2 library statically linked
in, as supplied from lestiff v0.88.1.  The Data Display Debugger (DDD)
is a common graphical user interface for GDB, DBX, and XDB, the popular
UNIX debuggers.  Besides ``classical'' front-end features such as
viewing source texts, DDD provides a graphical data display, where data
structures are displayed as graphs.  A simple mouse click dereferences
pointers or views structure contents, updated each time the program
stops.  Using DDD, you can reason about your application by viewing its
data, not just by viewing it execute lines of source code.  Other DDD
features include: debugging of programs written in C, C++, Ada, Fortran,
Java, Perl, Pascal, Modula-2, or Modula-3; machine-level debugging;
hypertext source navigation and lookup; breakpoint, backtrace, and
history editors; preferences and settings editors; program execution in
terminal emulator window; debugging on remote host; on-line manual;
interactive help on the Motif user interface; GDB/DBX/XDB command-line
interface with full editing, history, search, and completion
capabilities.  DDD has been designed to compete with well-known
commercial debuggers.  For more info on DDD see
http://www.cs.tu-bs.de/softech/ddd/

%package static
Summary: X interface to the GDB, DBX and XDB debuggers
Group: Development/Debuggers
Prefix: /usr

%description static
Completely statically linked DDD binary.  The Data Display Debugger
(DDD) is a common graphical user interface for GDB, DBX, and XDB, the
popular UNIX debuggers.  Besides ``classical'' front-end features such
as viewing source texts, DDD provides a graphical data display, where
data structures are displayed as graphs.  A simple mouse click
dereferences pointers or views structure contents, updated each time the
program stops.  Using DDD, you can reason about your application by
viewing its data, not just by viewing it execute lines of source code.
Other DDD features include: debugging of programs written in C, C++,
Ada, Fortran, Java, Perl, Pascal, Modula-2, or Modula-3; machine-level
debugging; hypertext source navigation and lookup; breakpoint,
backtrace, and history editors; preferences and settings editors;
program execution in terminal emulator window; debugging on remote host;
on-line manual; interactive help on the Motif user interface;
GDB/DBX/XDB command-line interface with full editing, history, search,
and completion capabilities.  DDD has been designed to compete with
well-known commercial debuggers.  For more info on DDD see
http://www.cs.tu-bs.de/softech/ddd/

%package doc
Summary: DDD documentation
Group: Development/Debuggers
Prefix: /usr

%description doc
This package contains various DDD documentation and a manual page.

%prep
%setup -q


%build
env CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure -v --prefix=/usr --with-motif-libraries=/usr/X11R6/lib --with-motif-includes=/usr/X11R6/include

MACHINE=`grep '^#.*host=' config.status | awk -F= '{print $5}'`
%define MACHINE $MACHINE

# The "dynamic" version ##################################################
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"
mv ddd/ddd-%{PACKAGE_VERSION}-%{MACHINE} ddd/ddd-%{PACKAGE_VERSION}-dynamic
#
# The "semistatic" version ###############################################
#
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" LIBXM="-Wl,-Bstatic -lXm -Wl,-Bdynamic"
mv ddd/ddd-%{PACKAGE_VERSION}-%{MACHINE} ddd/ddd-%{PACKAGE_VERSION}-semistatic
#
# The "static" version ###################################################
#
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" LDFLAGS="-Wl,-Bstatic"
mv ddd/ddd-%{PACKAGE_VERSION}-%{MACHINE} ddd/ddd-%{PACKAGE_VERSION}-static
#
mv doc/README doc/README.doc
gzip -9 doc/ddd-paper.ps
gzip -9 ChangeLog*

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/man/man1
mkdir -p $RPM_BUILD_ROOT/usr/doc/ddd-%{PACKAGE_VERSION}

install -s ddd/ddd-%{PACKAGE_VERSION}-dynamic $RPM_BUILD_ROOT/usr/bin
install -s ddd/ddd-%{PACKAGE_VERSION}-semistatic $RPM_BUILD_ROOT/usr/bin
install -s ddd/ddd-%{PACKAGE_VERSION}-static $RPM_BUILD_ROOT/usr/bin
install -m 644 ddd/ddd.man $RPM_BUILD_ROOT/usr/man/man1/ddd.1

# install docs by hand
DOCS="
ANNOUNCE
BUGS
COPYING
COPYING.LIB
ChangeLog*.gz
INSTALL
NEWS*
OPENBUGS
PROBLEMS
README
TIPS
TODO
doc/README.doc
doc/ddd-paper.ps.gz
doc/sample.dddinit
ddd/Ddd
"

cp -p ${DOCS} $RPM_BUILD_ROOT/usr/doc/ddd-%{PACKAGE_VERSION}
# cp -p $RPM_SOURCE_DIR/ddd-3.1.6-README.linux $RPM_BUILD_ROOT/usr/doc/ddd-%{PACKAGE_VERSION}
chmod -R a+rX-w $RPM_BUILD_ROOT/usr/doc/ddd-%{PACKAGE_VERSION}
chmod u+w $RPM_BUILD_ROOT/usr/doc/ddd-%{PACKAGE_VERSION}

%clean
rm -rf $RPM_BUILD_ROOT

%post dynamic
cd ${RPM_INSTALL_PREFIX-/usr}/bin && /bin/ln -sf ddd-%{PACKAGE_VERSION}-dynamic ddd

%post semistatic
cd ${RPM_INSTALL_PREFIX-/usr}/bin && /bin/ln -sf ddd-%{PACKAGE_VERSION}-semistatic ddd

%post static
cd ${RPM_INSTALL_PREFIX-/usr}/bin && /bin/ln -sf ddd-%{PACKAGE_VERSION}-static ddd

%postun dynamic
case "$1" in
	0) rm -f ${RPM_INSTALL_PREFIX-/usr}/bin/ddd;;
esac

%postun semistatic
case "$1" in
	0) rm -f ${RPM_INSTALL_PREFIX-/usr}/bin/ddd;;
esac

%postun static
case "$1" in
	0) rm -f ${RPM_INSTALL_PREFIX-/usr}/bin/ddd;;
esac

%files dynamic
%attr(555,bin,bin) /usr/bin/ddd-%{PACKAGE_VERSION}-dynamic

%files semistatic
%attr(555,bin,bin) /usr/bin/ddd-%{PACKAGE_VERSION}-semistatic

%files static
%attr(555,bin,bin) /usr/bin/ddd-%{PACKAGE_VERSION}-static

%files doc
%attr(-,root,root) /usr/doc/ddd-%{PACKAGE_VERSION}
%attr(444,root,root) /usr/man/man1/ddd.1

%changelog
* Tue Mar 21 2000 Rod m. Stewart <stewart@netwinder.org>
- update to version 3.2.1
- remove old patches

* Wed Aug 11 1999 Alec Habig <habig@budoe.bu.edu>

- updated to ddd-3.1.6, build with rpm v3.0.2 and glibc v2.1.1 on a 
  RH6.0 system, linked vs. lesstif v0.88.1
- 3.1.6-1 released

* Fri Aug 06 1999 Christian Joensson <chj@lin.foa.se>
 - Fixed typo of 3.1.4 in spec file.

* Wed May 19 1999 Alec Habig <habig@budoe.bu.edu>

- updated to ddd-3.1.5, build with rpm v3.0 and glibc v2.1 on a RH 6.0
  system, linked vs. lesstif v0.88.1
- 3.1.5-1 released

* Thu Apr 22 1999 Alec Habig <habig@budoe.bu.edu>

- Applied glibc2.1 patch from J.H.M. Dassen <jdassen@wi.leidenuniv.nl>.
  Applied RH Motif 2.1 patch from Eugene Kanter <eugene@bgs.com>.
  3.1.4-3 released.

* Wed Mar 31 1999 Alec Habig <habig@budoe.bu.edu>

- Fixed minor specfile typos, 3.1.4-2 released

* Sun Mar 28 1999 Alec Habig <habig@budoe.bu.edu>

- Updated to ddd-3.1.4 bugfix release, linked against lesstif-0.88,
  3.1.4-1 released.

* Fri Mar 19 1999 Ferdy Hanssen <hanssen@cs.utwente.nl>

- Compiled and linked with Metrolink Motif 2.1.10 instead of Lesstif
- Made RPM relocatable and buildable anywhere

* Mon Jan 11 1999 Alec Habig <habig@budoe.bu.edu>

- Updated to ddd-3.1.3 bugfix release, 3.1.3-1 released.

* Wed Dec 23 1998 Alec Habig <habig@budoe.bu.edu>

- Updated to ddd-3.1.2 bugfix release, 3.1.2-1 released.

* Fri Dec 11 1998 Alec Habig <habig@budoe.bu.edu>

- MACHINE was undefined in post script, and there's no good way for the
  rpm to know what it should be at that point.  Since /usr/bin isn't ever
  shared between arch's, it's safe to remove the MACHINE from the executable
  name.
- 3.1.1-2 released

* Mon Dec 07 1998 Alec Habig <habig@budoe.bu.edu>

- Fixed post symlink bug
- Updated to ddd-3.1.1 bugfix release

* Thu Dec 03 1998 Alec Habig <habig@budoe.bu.edu>

- Changed Packager and Distribution fields to comply with Red Hat Contrib|Net
  protocols.
- Called this ddd-3.1-2

* Thu Dec 03 1998 Alec Habig <habig@budoe.bu.edu>

- Updated to v3.1.
- Now built vs. lesstif v0.87.0

* Thu Aug 18 1998 Alec Habig <habig@budoe.bu.edu>

- fixed unconditional removal of /usr/bin/ddd symlink so that
  rpm -U doesn't clobber it (thanks to Chris Siebenmann
  <cks@hawkwind.utcs.toronto.edu> for pointing this out!).
- linked statics against lesstif-0.86.0 from lesstif.org
- released version 3.0-5.

* Wed Jul 29 1998 Alec Habig <habig@budoe.bu.edu>

- Merged Peter's changes into the spec file
- updated docs about lesstif version to use
- linked statics against lesstif-0.85.3 from lesstif.org
- released version 3.0-4.

* Sat Jul  4 1998 Peter Rye <prye@picu-sgh.demon.co.uk>

- Slightly modified Alec's spec file to package ddd 3.0.
- Patch to config.sub to configure for my Alpha SX164.
- Changed `uname -m` hack and version information to avoid hardwiring this
  into the spec file.
- Reversed the chown bin.bin post install

* Thu Jun 26 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-3.0-3 release
- linked vs. lesstif-0.85-2 with patch from ddd page, to fix
  crash in breakpoint menu.
- fixed ddd symlink problem.

* Mon Jun 22 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-3.0-2 released
- minor updates to docs.

* Mon Jun 22 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-3.0-1 released
- build of the ddd-3.0 release

* Sun May 31 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-2.99.99-1 released
- build of the ddd-2.99.99 beta release

* Sun May 31 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-2.99.9-1 released
- build of the ddd-2.99.9 beta release

* Fri May 28 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-2.99.2-1 released
- this rpm now built for glibc on a RH-5.1 system
- lesstif v0.84 now used for this build, instead of RH Motif v2.0
- build of the ddd-2.99.2 beta release

* Tue May 12 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-2.99.1-1 released
- build of the ddd-2.99.1 beta release

* Wed May 06 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-2.99-1 released
- build of the ddd-2.99 beta release

* Tue Feb 03 1998 Alec Habig <habig@budoe.bu.edu>
- ddd-2.2.3-2 released
- typo in post-install for static package fixed

* Mon Feb 02 1998 Alec Habig <habig@budoe.bu.edu>
- changelog added to specfile
- changed installed binary names from *-gnulibc1-* to *-libc5-* to avoid
  confusion.  Dunno why autoconf wants to call this gnulibc.
- chown'd all the installed stuff to bin.bin
- gzip'd the docs' ChangeLog
- librx and termcap subdirs are not getting passed the RPM compile opts via
  configure.  The changed opts exist in the config.status files, but something
  in the sed scripts is broken because they are being ignored when Makefile.in
  is turned into Makefile.  Thus, patches put back on the Makefile.in's in
  these dirs.

* Fri Jan 30 1998 Alec Habig <habig@budoe.bu.edu>
- Changes from ddd-2.2 spec file to update to 2.2.3 - mostly name changes
- Removed patches to Makefiles in exchange for suppliing the RPM build opts via
  a configure parameter.
- replace the hardwired "i586" in the programs names with a call to uname.
